/**************************************
Name:	x_bc.c

Date:	06/23/2002

Info:	evaluate a string input and
	output as number

Misc:	To be used with Xpreso

**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <values.h>

#include "x_bclib.h"


//  result = eval_braket(buffer, 0, strlen(buffer));


int do_op(char str[], int m_begin, int m_end){
  int m_idx, m_num1, m_num2, m_op;
  double num1, num2, value;

  char buff[2*256]="";
  char buff2[2*256]="";

  m_idx=m_num1=m_num2=m_op=0;
  num1=num2=0;

  strcpy(buff, str);

//first priority
  do{
    m_op=find_next_op(buff, m_num1+1, m_end);
    //m_num2=m_op+1;
    if( m_op>m_num1 && m_op<m_end ){
      if(buff[m_op]=='^'){
        sscanf(buff+m_num1, "%lf^%lf%s", &num1, &num2, buff2);
        value=pow(num1,num2);
        sprintf(buff+m_num1, "%.20f%s", value, buff2);
	buff2[0]='\0';
        num1=num2=0;
        m_end=strlen(buff);
      }else{
        m_num1=m_op+1;
      }
    }
  }while(m_op>0);

//second priority
  m_idx=m_num1=m_num2=m_op=0;
  num1=num2=0;

  do{
    m_op=find_next_op(buff, m_num1+1, m_end);
    //m_num2=m_op+1;
    if( m_op>m_num1 && m_op<m_end ){
      if (buff[m_op]=='*'){
        sscanf(buff+m_num1, "%lf*%lf%s", &num1, &num2, buff2);
        value=num1*num2;
        sprintf(buff+m_num1, "%.20f%s", value, buff2);
	buff2[0]='\0';
        num1=num2=0;
        m_end=strlen(buff);
      }else if(buff[m_op]=='/'){
        sscanf(buff+m_num1, "%lf/%lf%s", &num1, &num2, buff2);
        value=num1/num2;
        if(num2==0){
          if(num1>=0)
            value=MAXDOUBLE;
          else
            value=-(MAXDOUBLE-1);
        }
        sprintf(buff+m_num1, "%.20f%s", value, buff2);
	buff2[0]='\0';
        num1=num2=0;
        m_end=strlen(buff);
      }else{
        m_num1=m_op+1;
      }
    }
  }while(m_op>0&&m_op<strlen(buff));

//third priority
  m_idx=m_num1=m_num2=m_op=0;
  num1=num2=0;

  do{
    m_op=find_next_op(buff, m_num1+1, m_end);
    //m_num2=m_op+1;
    if( m_op>m_num1 && m_op<m_end ){
      if (buff[m_op]=='+'){
        sscanf(buff+m_num1, "%lf+%lf%s", &num1, &num2, buff2);
        value=num1+num2;
        sprintf(buff+m_num1, "%.20f%s", value, buff2);
        buff2[0]='\0';
        num1=num2=0;
        m_end=strlen(buff);
      }else if(buff[m_op]=='-'){
        sscanf(buff+m_num1, "%lf-%lf%s", &num1, &num2, buff2);
        value=num1-num2;
        sprintf(buff+m_num1, "%.20f%s", value, buff2);
        buff2[0]='\0';
        num1=num2=0;
        m_end=strlen(buff);
      }else{
        m_num1=m_op+1;
      }
    }
  }while(m_op>0&&m_op<strlen(buff));


  strcpy(str, buff);

  return(0);
}

double evaluate(char str[], int m_begin, int m_end){
  double num1, num2, value;

  char buff[2*256]="";

  num1=num2=0;

  strncpy(buff, str+m_begin, m_end-m_begin);
  buff[m_end-m_begin+1]='\0';

  do_op(buff, 0, strlen(buff));

  sscanf(buff, "%lf", &value);
  return(value);

}

int replace(char str1[], char str2[], double value){
  int i;
  char buff[2*256]="";

  for(i=0; i< strlen(str1); i++){
    if(strncasecmp(str1+i, str2, strlen(str2))==0){
      strcpy(buff, str1);
      sprintf(str1+i, "%.20f%s", value, buff+i+strlen(str2));
      strcpy(buff, str1);
    }
  }

  return(0);
}


int find_next_num(char str[], int m_begin, int m_end){
  int m_idx;

  for(m_idx=m_begin; m_idx<m_end; m_idx++){
    if((str[m_idx]>'0' && str[m_idx]<'9')||str[m_idx]=='.' )
      break;
  }

  if(m_idx>=m_end)
    m_idx=m_end;

  return (m_idx);
}

int find_next_op(char str[], int m_begin, int m_end){
  int m_idx=m_begin;

  for(m_idx=m_begin; m_idx<m_end; m_idx++){
    if(str[m_idx]=='+'||str[m_idx]=='-'||
       str[m_idx]=='*'||str[m_idx]=='/'||
       str[m_idx]=='^'||str[m_idx]=='('||
       str[m_idx]==')')
      break;
  }

  if(m_idx>=m_end)
    m_idx=-1;

  return m_idx;
}

int check_braket(char str[], int m_begin, int m_end){
  int i, m_count=0;

  for(i=m_begin; i< m_end; i++){
    if(str[i]=='(')
      m_count++;
    else if(str[i]==')')
      m_count--;
  }
    return m_count;
}


double eval_braket(char str[], int m_begin, int m_end){
  int i, m_bra, m_ket;
  double value;

  char buff[2*256]="";
  char buff2[2*256]="";

  m_bra=m_ket=-1;
  value=0;

  strncpy(buff, str+m_begin, m_end-m_begin);
  buff[m_end-m_begin]='\0';

  replace(buff, "pi", 3.14159265358979323846);
  replace(buff, "exp", 2.7182818284590452354);

  for(i=m_begin; i< strlen(buff); i++){
    if(buff[i]=='(')
      m_bra=i;
    else if(buff[i]==')' && m_bra!=-1){
      m_ket=i;
      strncpy(buff2, buff+m_bra+1, m_ket-m_bra-1);
      buff2[m_ket-m_bra-1]='\0';
      value=evaluate(buff2, 0, m_ket-m_bra-1);

      if(m_bra-4>=0){
	m_bra-=4;
	if(strncasecmp(buff+m_bra, "sqrt", 4)==0)
	  value=sqrt(value);
	else if(strncasecmp(buff+m_bra, "cbrt", 4)==0)
	  value=cbrt(value);
	else if(strncasecmp(buff+m_bra, "asin", 4)==0)
	  value=asin(value);
	else if(strncasecmp(buff+m_bra, "acos", 4)==0)
	  value=acos(value);
	else if(strncasecmp(buff+m_bra, "atan", 4)==0)
	  value=atan(value);
	else
	  m_bra+=4;
      }

     if(m_bra-3>=0){
        m_bra-=3;
	if(strncasecmp(buff+m_bra, "log", 3)==0){
          if(value>0)
            value=log10(value);
          else
            value=-(MAXDOUBLE-1);}
	else if(strncasecmp(buff+m_bra, "sin", 3)==0)
	  value=sin(value);
	else if(strncasecmp(buff+m_bra, "cos", 3)==0)
	  value=cos(value);
	else if(strncasecmp(buff+m_bra, "tan", 3)==0)
	  value=tan(value);
	else if(strncasecmp(buff+m_bra, "deg", 3)==0)
	  value=value*180/3.14159265358979323846;
	else if(strncasecmp(buff+m_bra, "rad", 3)==0)
	  value=value*3.14159265358979323846/180;
	else
	  m_bra+=3;
      }
      if((m_bra-2)>=0){
	m_bra-=2;
	if(strncasecmp(buff+m_bra, "ln", 2)==0)
          if(value>0)
	    value=log(value);
          else
            value=-(MAXDOUBLE-1);
	else
	  m_bra+=2;
      }
      
      strcpy(buff2, buff);
      sprintf(buff2+m_bra, "%.20f%s", value, buff+m_ket+1);
      strcpy(buff, buff2);
      m_end=strlen(buff);
      i=m_begin-1;
    }
  }

  value=evaluate(buff, 0, strlen(buff));

  return(value);
}


